/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-07-30 23:41
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef long double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

const int MAXN = 2e5 + 5;
ll N;

void solve(){
    // Code goes here ...
    cin >> N;

    int obj;
    vector<int> nums(10), onums(10);
    R(i, N){
        cin >> obj;
        nums[obj]++;
    }

    // first prompt
    vector<vector<int>> poss(10);
    int curform = 0;
    cout << "- 0" << endl;
    cout.flush();
    F(i, 1, N+1){
        cin >> obj;
        onums[obj]++;
        poss[obj].emplace_back(i);
    }
    R(i, 10)
        if(onums[i] > nums[i])
            curform = i;

    // possible second prompt
    if(curform == 0){
        cout << "- 0" << endl;
        cout.flush();
        onums = vector<int>(10);
        poss = vector<vector<int>>(10);
        F(i, 1, N+1){
            cin >> obj;
            onums[obj]++;
            poss[obj].emplace_back(i);
        }
        R(i, 10)
            if(onums[i] > nums[i])
                curform = i;
    }
    assert(curform != 0);

    // third prompt
    int numRemObjs = onums[curform];
    int numDelObjs = N - numRemObjs;
    cout << "- " << numDelObjs << " ";
    R(i, 10)
        if(i != curform)
            for(auto id: poss[i])
                cout << id << " ";
    cout << endl;
    cout.flush();
    
    int pos = 0;
    R(i, numRemObjs){
        cin >> obj;
        if(obj != curform)
            pos = i + 1;
    }

    // possible fourth prompt
    if(pos == 0){
        cout << "- 0" << endl;
        cout.flush();
        R(i, numRemObjs){
            cin >> obj;
            if(obj != curform)
                pos = i + 1;
        }
    }

    // eventually fifth prompt
    cout << "! " << pos << endl;
    cout.flush();
}

int main(){
    cout << fixed << setprecision(8);
    int T;
    cin >> T;
    while(T--)
        solve();
}
        
